//COPY SETUP SCRIPT

//Let's make a new monitor for this power-up :D
freeslot(
"MT_COPYPLAYER_BOX",
"MT_COPYPLAYER_GOLDBOX",
"MT_COPYICON",
"S_COPYPLAYER_BOX",
"S_COPYPLAYER_GOLDBOX",
"S_COPYPLAYER_ICON1",
"S_COPYPLAYER_ICON2",
"SPR_TVCH"
)

//Normal Copy Monitor Setup
mobjinfo[MT_COPYPLAYER_BOX] = {
//$Name "Copy Player Monitor"
//$Sprite TVCHA0
//$Category "Monitors"
	doomednum = 2998,
	spawnstate = S_COPYPLAYER_BOX,
	reactiontime = 8,
	spawnhealth = 1,
	painstate = S_COPYPLAYER_BOX,
	deathstate = S_BOX_POP1,
	deathsound = sfx_pop,
	radius = 18*FRACUNIT,
	height = 48*FRACUNIT,
	speed = 1,
	mass = 100,
	damage = MT_COPYICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
states[S_COPYPLAYER_BOX] = {SPR_TVCH, A, 2, nil, 0, 0, S_BOX_FLICKER}

//Golden Copy Monitor Setup
mobjinfo[MT_COPYPLAYER_GOLDBOX] = {
//$Name "Copy Player Monitor (Respawn)"
//$Sprite TVCHB0
//$Category "Monitors (Respawning)"
	doomednum = 2999,
	spawnstate = S_COPYPLAYER_GOLDBOX,
	reactiontime = 8,
	spawnhealth = 1,
	painstate = S_COPYPLAYER_GOLDBOX,
	deathstate = S_GOLDBOX_OFF1,
	deathsound = sfx_pop,
	radius = 18*FRACUNIT,
	height = 48*FRACUNIT,
	speed = 1,
	mass = 100,
	damage = MT_COPYICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR|MF_GRENADEBOUNCE
}
states[S_COPYPLAYER_GOLDBOX] = {SPR_TVCH, B, 2, nil, 0, 0, S_GOLDBOX_FLICKER}

//Copy Monitor Icon Setup
mobjinfo[MT_COPYICON] = {
	doomednum = -1,
	spawnstate = S_COPYPLAYER_ICON1,
	seesound = sfx_itemup,
	reactiontime = 10,
	spawnhealth = 1,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	speed = 2*FRACUNIT,	
	mass = 100,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

addHook("PlayerSpawn", function(player)
	player.mo.copytable = {} -- Reset table
end)

function A_CopyPlayer(actor)
	if actor.target and actor.target.valid
		local mo = actor.target
		//Normal spawning setup
		if #mo.copytable < 4
			if not (mo.missingcopy)
				local copy = P_SpawnMobj(mo.x+mo.momx, mo.y+mo.momy, mo.z+mo.momz, MT_PLAYER)
				copy.color = mo.color
				copy.state = mo.state
				copy.skin = mo.skin
				copy.sprite2 = mo.sprite2
				copy.flags = ($|(MF_PUSHABLE|MF_NOCLIPTHING)) & ~(MF_SOLID|MF_SHOOTABLE)
				copy.spawntimer = 18
				table.insert(mo.copytable, copy)
			end
		end
		
		//Alternate spawning setup - for (sort of) dead copies, iterator used here for bringing back
		//a dead copy from the former key entry rather than a latter key entry.
		if #mo.copytable <= 4 and mo.missingcopy
			local key
			local keys = {1, 2, 3, 4}	
			for k,v in ipairs(mo.copytable)
				if not (v.flags & MF_NOCLIP) continue end
				key = v.key
				if v.key == keys[v.key] break end
			end
			if mo.copytable[key] and mo.copytable[key].valid
				mo.copytable[key].flags = ($|(MF_PUSHABLE|MF_NOCLIPTHING)) & ~(MF_NOCLIP|MF_SCENERY)
				mo.copytable[key].flags2 = $&~(MF2_DONTDRAW)
				mo.copytable[key].spawntimer = 18
			else
				if #mo.copytable < 4
					local copy = P_SpawnMobj(mo.x+mo.momx, mo.y+mo.momy, mo.z+mo.momz, MT_PLAYER)
					copy.color = mo.color
					copy.state = mo.state
					copy.skin = mo.skin
					copy.sprite2 = mo.sprite2
					copy.flags = ($|(MF_PUSHABLE|MF_NOCLIPTHING)) & ~(MF_SOLID|MF_SHOOTABLE)
					copy.spawntimer = 18
					table.insert(mo.copytable, copy)
				end
			end
		end
	end
end

states[S_COPYPLAYER_ICON1] = {SPR_TVCH, FF_ANIMATE|C, 18, nil, 3, 4, S_COPYPLAYER_ICON2}
states[S_COPYPLAYER_ICON2] = {SPR_TVCH, C, 18, A_CopyPlayer, 0, 0, S_NULL}

//Let's change all of the monitors in a map to one of our special monitor for now.
addHook("MapLoad", do
	for mobj in mobjs.iterate()
		if not (mobj.flags & MF_MONITOR) continue end
		if mobj.type != MT_RING_BOX continue end
		mobj.type = MT_COPYPLAYER_BOX
	end
end)

//FOF stuff - for making sure that shatter/bustable blocks set across multiple sectors with the same tag can all be broken together
rawset(_G, "secf", {})
addHook("MapLoad", do
	secf = {}
	for sector in sectors.iterate do
		for rover in sector.ffloors()
			if not (rover.valid) continue end
			if not (rover.flags & FF_EXISTS) continue end
			if rover.master.special < 252 or rover.master.special > 256 continue end
			table.insert(secf, rover) -- Grab FOFs
		end
	end
end)

//For breaking shatter/bustable FOFs and activating linedef executors that might be referenced by them
rawset(_G, "BreakAndOrTrigger", function(ffloor, mobj, sector) -- Third argument refers to FOF's target sector
	if ffloor.flags & FF_EXISTS
		if ffloor.master.flags & ML_EFFECT5
			local tag = R_PointToDist2(ffloor.master.v1.x, ffloor.master.v1.y, ffloor.master.v2.x, ffloor.master.v2.y)/FRACUNIT
			P_LinedefExecute(tag, mobj.pmo, mobj.subsector.sector) -- player mobj as 2nd arg for activating linedefs that rely on player userdata
		end
		EV_CrumbleChain(sector, ffloor)
		
		for k, ff in ipairs(secf)
			if ff.target.tag != sector.tag continue end
			if ff.topheight != ffloor.topheight continue end
			if ff.bottomheight != ffloor.bottomheight continue end
			EV_CrumbleChain(ff.target, ff)
		end
	end
end)

//Special linedef for checking the no. of copies and activating a specified linedef
//Note: Useful for triggering linedef types that rely on the player's userdata
//Important note: No need to remove clones' data from "copylist" table as it automatically resets once this function is called again
local function CopyChecker(line, mobj)
	local sector = mobj.subsector.sector
	local side = line.frontside
	local xoff = side.textureoffset/FRACUNIT
	local tag = line.tag
	local copylist = {} -- new table/reset table

	if mobj.type == MT_PLAYER
		if mobj.flags & MF_PUSHABLE or (mobj.flags & (MF_NOCLIP|MF_SCENERY)) == (MF_NOCLIP|MF_SCENERY)
			for copy in sector.thinglist()
				if copy.flags != mobj.flags continue end
				table.insert(copylist, copy)
				//print(copy, #copylist, xoff)
			end
			
			if not (line.flags & (ML_NOCLIMB|ML_EFFECT4)) and #copylist == xoff -- Clone no. == x-offset
			or line.flags & ML_NOCLIMB and #copylist >= xoff  -- Clone no. >= x-offset (Not Climbable Flag)
			or line.flags & ML_EFFECT4 and #copylist <= xoff  -- Clone no. <= x-offset (Solid Midtexture Flag)
				P_LinedefExecute(tag, mobj.pmo, sector) -- player mobj as 2nd arg for activating linedefs that rely on player userdata
			end
		end
	end
end
addHook("LinedefExecute", CopyChecker, "P_CCHECK")